#pragma once

#include <vector>
#include <array>
#include <boost/geometry.hpp>

#include <boost/units/systems/si.hpp>
#include <boost/units/systems/si/io.hpp>
#include <boost/units/systems/si/plane_angle.hpp>
#include <boost/units/systems/si/prefixes.hpp>
#include <boost/units/systems/angle/degrees.hpp>


namespace bg = boost::geometry;
namespace bu = boost::units;
namespace snake {

typedef bg::model::point<double, 2, bg::cs::cartesian>  BoostPoint;
//typedef std::vector<BoostPoint>                        BoostPointList;
typedef bg::model::polygon<BoostPoint>                  BoostPolygon;
typedef bg::model::linestring<BoostPoint>               BoostLineString;
typedef std::vector<std::vector<int64_t>>               Int64Matrix;
typedef bg::model::box<BoostPoint>                      BoostBox;

typedef bu::quantity<bu::si::length, double> Length;
typedef bu::quantity<bu::si::area, double> Area;
typedef bu::quantity<bu::si::plane_angle, double> Angle;

}
